// Code generated by pigeon; DO NOT EDIT.

package nosql

import (
	"bytes"
	"errors"
	"fmt"
	"io"
	"math"
	"os"
	"sort"
	"strconv"
	"strings"
	"sync"
	"unicode"
	"unicode/utf8"

	"github.com/pikami/cosmium/parsers"
)

func makeSelectStmt(columns, table, whereClause interface{}) (parsers.SelectStmt, error) {
	selectStmt := parsers.SelectStmt{
		Columns: columns.([]parsers.FieldPath),
		Table:   table.(parsers.Table),
	}

	if filters, ok := whereClause.(parsers.ComparisonExpression); ok {
		selectStmt.Filters = filters
	} else if filters, ok := whereClause.(parsers.LogicalExpression); ok {
		selectStmt.Filters = filters
	}

	return selectStmt, nil
}

func makeFieldPath(name interface{}, path interface{}, alias interface{}) (parsers.FieldPath, error) {
	ps := path.([]interface{})

	paths := make([]string, 1)
	paths[0] = name.(string)
	for _, p := range ps {
		paths = append(paths, p.(string))
	}

	fieldPath := parsers.FieldPath{Path: paths}
	if aliasValue, ok := alias.(string); ok {
		fieldPath.Alias = aliasValue
	}

	return fieldPath, nil
}

func makeColumnList(column interface{}, other_columns interface{}) ([]parsers.FieldPath, error) {
	collsAsArray := other_columns.([]interface{})
	columnList := make([]parsers.FieldPath, len(collsAsArray)+1)
	columnList[0] = column.(parsers.FieldPath)

	for i, v := range collsAsArray {
		if col, ok := v.(parsers.FieldPath); ok {
			columnList[i+1] = col
		}
	}

	return columnList, nil
}

func joinStrings(array []interface{}) string {
	var stringsArray []string
	for _, elem := range array {
		str, ok := elem.(string)
		if !ok {
			continue
		}
		stringsArray = append(stringsArray, str)
	}

	return strings.Join(stringsArray, "")
}

func combineExpressions(ex1 interface{}, exs interface{}, operation parsers.LogicalExpressionType) (interface{}, error) {
	if exs == nil || len(exs.([]interface{})) < 1 {
		return ex1, nil
	}

	return parsers.LogicalExpression{
		Expressions: append([]interface{}{ex1}, exs.([]interface{})...),
		Operation:   operation,
	}, nil
}

var g = &grammar{
	rules: []*rule{
		{
			name: "Input",
			pos:  position{line: 78, col: 1, offset: 1970},
			expr: &actionExpr{
				pos: position{line: 78, col: 10, offset: 1979},
				run: (*parser).callonInput1,
				expr: &labeledExpr{
					pos:   position{line: 78, col: 10, offset: 1979},
					label: "selectStmt",
					expr: &ruleRefExpr{
						pos:  position{line: 78, col: 21, offset: 1990},
						name: "SelectStmt",
					},
				},
			},
		},
		{
			name: "SelectStmt",
			pos:  position{line: 82, col: 1, offset: 2033},
			expr: &actionExpr{
				pos: position{line: 82, col: 15, offset: 2047},
				run: (*parser).callonSelectStmt1,
				expr: &seqExpr{
					pos: position{line: 82, col: 15, offset: 2047},
					exprs: []any{
						&ruleRefExpr{
							pos:  position{line: 82, col: 15, offset: 2047},
							name: "Select",
						},
						&ruleRefExpr{
							pos:  position{line: 82, col: 22, offset: 2054},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 82, col: 25, offset: 2057},
							label: "columns",
							expr: &ruleRefExpr{
								pos:  position{line: 82, col: 33, offset: 2065},
								name: "ColumnList",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 82, col: 44, offset: 2076},
							name: "ws",
						},
						&ruleRefExpr{
							pos:  position{line: 83, col: 5, offset: 2083},
							name: "From",
						},
						&ruleRefExpr{
							pos:  position{line: 83, col: 10, offset: 2088},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 83, col: 13, offset: 2091},
							label: "table",
							expr: &ruleRefExpr{
								pos:  position{line: 83, col: 19, offset: 2097},
								name: "TableName",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 83, col: 29, offset: 2107},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 84, col: 5, offset: 2114},
							label: "whereClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 84, col: 17, offset: 2126},
								expr: &actionExpr{
									pos: position{line: 84, col: 18, offset: 2127},
									run: (*parser).callonSelectStmt15,
									expr: &seqExpr{
										pos: position{line: 84, col: 18, offset: 2127},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 84, col: 18, offset: 2127},
												name: "ws",
											},
											&ruleRefExpr{
												pos:  position{line: 84, col: 21, offset: 2130},
												name: "Where",
											},
											&ruleRefExpr{
												pos:  position{line: 84, col: 27, offset: 2136},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 84, col: 30, offset: 2139},
												label: "condition",
												expr: &ruleRefExpr{
													pos:  position{line: 84, col: 40, offset: 2149},
													name: "Condition",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "ColumnList",
			pos:  position{line: 88, col: 1, offset: 2247},
			expr: &actionExpr{
				pos: position{line: 88, col: 15, offset: 2261},
				run: (*parser).callonColumnList1,
				expr: &seqExpr{
					pos: position{line: 88, col: 15, offset: 2261},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 88, col: 15, offset: 2261},
							label: "column",
							expr: &ruleRefExpr{
								pos:  position{line: 88, col: 22, offset: 2268},
								name: "FieldPath",
							},
						},
						&labeledExpr{
							pos:   position{line: 88, col: 32, offset: 2278},
							label: "other_columns",
							expr: &zeroOrMoreExpr{
								pos: position{line: 88, col: 46, offset: 2292},
								expr: &actionExpr{
									pos: position{line: 88, col: 47, offset: 2293},
									run: (*parser).callonColumnList7,
									expr: &seqExpr{
										pos: position{line: 88, col: 47, offset: 2293},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 88, col: 47, offset: 2293},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 88, col: 50, offset: 2296},
												val:        ",",
												ignoreCase: false,
												want:       "\",\"",
											},
											&ruleRefExpr{
												pos:  position{line: 88, col: 54, offset: 2300},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 88, col: 57, offset: 2303},
												label: "coll",
												expr: &ruleRefExpr{
													pos:  position{line: 88, col: 62, offset: 2308},
													name: "FieldPath",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "TableName",
			pos:  position{line: 92, col: 1, offset: 2394},
			expr: &actionExpr{
				pos: position{line: 92, col: 14, offset: 2407},
				run: (*parser).callonTableName1,
				expr: &labeledExpr{
					pos:   position{line: 92, col: 14, offset: 2407},
					label: "key",
					expr: &ruleRefExpr{
						pos:  position{line: 92, col: 18, offset: 2411},
						name: "Identifier",
					},
				},
			},
		},
		{
			name: "FieldPath",
			pos:  position{line: 96, col: 1, offset: 2478},
			expr: &actionExpr{
				pos: position{line: 96, col: 14, offset: 2491},
				run: (*parser).callonFieldPath1,
				expr: &seqExpr{
					pos: position{line: 96, col: 14, offset: 2491},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 96, col: 14, offset: 2491},
							label: "name",
							expr: &ruleRefExpr{
								pos:  position{line: 96, col: 19, offset: 2496},
								name: "Identifier",
							},
						},
						&labeledExpr{
							pos:   position{line: 96, col: 30, offset: 2507},
							label: "path",
							expr: &zeroOrMoreExpr{
								pos: position{line: 96, col: 35, offset: 2512},
								expr: &choiceExpr{
									pos: position{line: 96, col: 36, offset: 2513},
									alternatives: []any{
										&ruleRefExpr{
											pos:  position{line: 96, col: 36, offset: 2513},
											name: "DotFieldAccess",
										},
										&ruleRefExpr{
											pos:  position{line: 96, col: 53, offset: 2530},
											name: "ArrayFieldAccess",
										},
									},
								},
							},
						},
						&labeledExpr{
							pos:   position{line: 97, col: 5, offset: 2553},
							label: "asClause",
							expr: &zeroOrOneExpr{
								pos: position{line: 97, col: 14, offset: 2562},
								expr: &actionExpr{
									pos: position{line: 97, col: 15, offset: 2563},
									run: (*parser).callonFieldPath12,
									expr: &seqExpr{
										pos: position{line: 97, col: 15, offset: 2563},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 97, col: 15, offset: 2563},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 97, col: 18, offset: 2566},
												val:        "AS",
												ignoreCase: false,
												want:       "\"AS\"",
											},
											&ruleRefExpr{
												pos:  position{line: 97, col: 23, offset: 2571},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 97, col: 26, offset: 2574},
												label: "alias",
												expr: &ruleRefExpr{
													pos:  position{line: 97, col: 32, offset: 2580},
													name: "Identifier",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "DotFieldAccess",
			pos:  position{line: 101, col: 1, offset: 2667},
			expr: &actionExpr{
				pos: position{line: 101, col: 19, offset: 2685},
				run: (*parser).callonDotFieldAccess1,
				expr: &seqExpr{
					pos: position{line: 101, col: 19, offset: 2685},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 101, col: 19, offset: 2685},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&labeledExpr{
							pos:   position{line: 101, col: 23, offset: 2689},
							label: "id",
							expr: &ruleRefExpr{
								pos:  position{line: 101, col: 26, offset: 2692},
								name: "Identifier",
							},
						},
					},
				},
			},
		},
		{
			name: "ArrayFieldAccess",
			pos:  position{line: 105, col: 1, offset: 2727},
			expr: &actionExpr{
				pos: position{line: 105, col: 21, offset: 2747},
				run: (*parser).callonArrayFieldAccess1,
				expr: &seqExpr{
					pos: position{line: 105, col: 21, offset: 2747},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 105, col: 21, offset: 2747},
							val:        "[\"",
							ignoreCase: false,
							want:       "\"[\\\"\"",
						},
						&labeledExpr{
							pos:   position{line: 105, col: 27, offset: 2753},
							label: "id",
							expr: &ruleRefExpr{
								pos:  position{line: 105, col: 30, offset: 2756},
								name: "Identifier",
							},
						},
						&litMatcher{
							pos:        position{line: 105, col: 41, offset: 2767},
							val:        "\"]",
							ignoreCase: false,
							want:       "\"\\\"]\"",
						},
					},
				},
			},
		},
		{
			name: "Identifier",
			pos:  position{line: 109, col: 1, offset: 2797},
			expr: &actionExpr{
				pos: position{line: 109, col: 15, offset: 2811},
				run: (*parser).callonIdentifier1,
				expr: &seqExpr{
					pos: position{line: 109, col: 15, offset: 2811},
					exprs: []any{
						&charClassMatcher{
							pos:        position{line: 109, col: 15, offset: 2811},
							val:        "[a-zA-Z_]",
							chars:      []rune{'_'},
							ranges:     []rune{'a', 'z', 'A', 'Z'},
							ignoreCase: false,
							inverted:   false,
						},
						&zeroOrMoreExpr{
							pos: position{line: 109, col: 24, offset: 2820},
							expr: &charClassMatcher{
								pos:        position{line: 109, col: 24, offset: 2820},
								val:        "[a-zA-Z0-9_]",
								chars:      []rune{'_'},
								ranges:     []rune{'a', 'z', 'A', 'Z', '0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "Condition",
			pos:  position{line: 113, col: 1, offset: 2870},
			expr: &actionExpr{
				pos: position{line: 113, col: 14, offset: 2883},
				run: (*parser).callonCondition1,
				expr: &labeledExpr{
					pos:   position{line: 113, col: 14, offset: 2883},
					label: "expression",
					expr: &ruleRefExpr{
						pos:  position{line: 113, col: 25, offset: 2894},
						name: "OrExpression",
					},
				},
			},
		},
		{
			name: "OrExpression",
			pos:  position{line: 117, col: 1, offset: 2939},
			expr: &actionExpr{
				pos: position{line: 117, col: 17, offset: 2955},
				run: (*parser).callonOrExpression1,
				expr: &seqExpr{
					pos: position{line: 117, col: 17, offset: 2955},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 117, col: 17, offset: 2955},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 117, col: 21, offset: 2959},
								name: "AndExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 117, col: 35, offset: 2973},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 117, col: 39, offset: 2977},
								expr: &actionExpr{
									pos: position{line: 117, col: 40, offset: 2978},
									run: (*parser).callonOrExpression7,
									expr: &seqExpr{
										pos: position{line: 117, col: 40, offset: 2978},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 117, col: 40, offset: 2978},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 117, col: 43, offset: 2981},
												val:        "OR",
												ignoreCase: false,
												want:       "\"OR\"",
											},
											&ruleRefExpr{
												pos:  position{line: 117, col: 48, offset: 2986},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 117, col: 51, offset: 2989},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 117, col: 54, offset: 2992},
													name: "AndExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "AndExpression",
			pos:  position{line: 121, col: 1, offset: 3105},
			expr: &actionExpr{
				pos: position{line: 121, col: 18, offset: 3122},
				run: (*parser).callonAndExpression1,
				expr: &seqExpr{
					pos: position{line: 121, col: 18, offset: 3122},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 121, col: 18, offset: 3122},
							label: "ex1",
							expr: &ruleRefExpr{
								pos:  position{line: 121, col: 22, offset: 3126},
								name: "ComparisonExpression",
							},
						},
						&labeledExpr{
							pos:   position{line: 121, col: 43, offset: 3147},
							label: "ex2",
							expr: &zeroOrMoreExpr{
								pos: position{line: 121, col: 47, offset: 3151},
								expr: &actionExpr{
									pos: position{line: 121, col: 48, offset: 3152},
									run: (*parser).callonAndExpression7,
									expr: &seqExpr{
										pos: position{line: 121, col: 48, offset: 3152},
										exprs: []any{
											&ruleRefExpr{
												pos:  position{line: 121, col: 48, offset: 3152},
												name: "ws",
											},
											&litMatcher{
												pos:        position{line: 121, col: 51, offset: 3155},
												val:        "AND",
												ignoreCase: false,
												want:       "\"AND\"",
											},
											&ruleRefExpr{
												pos:  position{line: 121, col: 57, offset: 3161},
												name: "ws",
											},
											&labeledExpr{
												pos:   position{line: 121, col: 60, offset: 3164},
												label: "ex",
												expr: &ruleRefExpr{
													pos:  position{line: 121, col: 63, offset: 3167},
													name: "ComparisonExpression",
												},
											},
										},
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "ComparisonExpression",
			pos:  position{line: 125, col: 1, offset: 3288},
			expr: &actionExpr{
				pos: position{line: 125, col: 25, offset: 3312},
				run: (*parser).callonComparisonExpression1,
				expr: &seqExpr{
					pos: position{line: 125, col: 25, offset: 3312},
					exprs: []any{
						&labeledExpr{
							pos:   position{line: 125, col: 25, offset: 3312},
							label: "left",
							expr: &choiceExpr{
								pos: position{line: 125, col: 31, offset: 3318},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 125, col: 31, offset: 3318},
										name: "Literal",
									},
									&ruleRefExpr{
										pos:  position{line: 125, col: 41, offset: 3328},
										name: "FieldPath",
									},
								},
							},
						},
						&ruleRefExpr{
							pos:  position{line: 125, col: 52, offset: 3339},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 125, col: 55, offset: 3342},
							label: "op",
							expr: &ruleRefExpr{
								pos:  position{line: 125, col: 58, offset: 3345},
								name: "ComparisonOperator",
							},
						},
						&ruleRefExpr{
							pos:  position{line: 125, col: 77, offset: 3364},
							name: "ws",
						},
						&labeledExpr{
							pos:   position{line: 125, col: 80, offset: 3367},
							label: "right",
							expr: &choiceExpr{
								pos: position{line: 125, col: 87, offset: 3374},
								alternatives: []any{
									&ruleRefExpr{
										pos:  position{line: 125, col: 87, offset: 3374},
										name: "Literal",
									},
									&ruleRefExpr{
										pos:  position{line: 125, col: 97, offset: 3384},
										name: "FieldPath",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "Select",
			pos:  position{line: 129, col: 1, offset: 3499},
			expr: &choiceExpr{
				pos: position{line: 129, col: 12, offset: 3510},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 129, col: 12, offset: 3510},
						val:        "select",
						ignoreCase: false,
						want:       "\"select\"",
					},
					&litMatcher{
						pos:        position{line: 129, col: 23, offset: 3521},
						val:        "SELECT",
						ignoreCase: false,
						want:       "\"SELECT\"",
					},
				},
			},
		},
		{
			name: "From",
			pos:  position{line: 131, col: 1, offset: 3532},
			expr: &choiceExpr{
				pos: position{line: 131, col: 10, offset: 3541},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 131, col: 10, offset: 3541},
						val:        "from",
						ignoreCase: false,
						want:       "\"from\"",
					},
					&litMatcher{
						pos:        position{line: 131, col: 19, offset: 3550},
						val:        "FROM",
						ignoreCase: false,
						want:       "\"FROM\"",
					},
				},
			},
		},
		{
			name: "Where",
			pos:  position{line: 133, col: 1, offset: 3559},
			expr: &choiceExpr{
				pos: position{line: 133, col: 11, offset: 3569},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 133, col: 11, offset: 3569},
						val:        "where",
						ignoreCase: false,
						want:       "\"where\"",
					},
					&litMatcher{
						pos:        position{line: 133, col: 21, offset: 3579},
						val:        "WHERE",
						ignoreCase: false,
						want:       "\"WHERE\"",
					},
				},
			},
		},
		{
			name: "ComparisonOperator",
			pos:  position{line: 135, col: 1, offset: 3589},
			expr: &choiceExpr{
				pos: position{line: 135, col: 23, offset: 3611},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 135, col: 23, offset: 3611},
						val:        "=",
						ignoreCase: false,
						want:       "\"=\"",
					},
					&litMatcher{
						pos:        position{line: 135, col: 29, offset: 3617},
						val:        "!=",
						ignoreCase: false,
						want:       "\"!=\"",
					},
					&litMatcher{
						pos:        position{line: 135, col: 36, offset: 3624},
						val:        "<",
						ignoreCase: false,
						want:       "\"<\"",
					},
					&litMatcher{
						pos:        position{line: 135, col: 42, offset: 3630},
						val:        "<=",
						ignoreCase: false,
						want:       "\"<=\"",
					},
					&litMatcher{
						pos:        position{line: 135, col: 49, offset: 3637},
						val:        ">",
						ignoreCase: false,
						want:       "\">\"",
					},
					&actionExpr{
						pos: position{line: 135, col: 55, offset: 3643},
						run: (*parser).callonComparisonOperator7,
						expr: &litMatcher{
							pos:        position{line: 135, col: 55, offset: 3643},
							val:        ">=",
							ignoreCase: false,
							want:       "\">=\"",
						},
					},
				},
			},
		},
		{
			name: "Literal",
			pos:  position{line: 139, col: 1, offset: 3684},
			expr: &choiceExpr{
				pos: position{line: 139, col: 12, offset: 3695},
				alternatives: []any{
					&ruleRefExpr{
						pos:  position{line: 139, col: 12, offset: 3695},
						name: "FloatLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 139, col: 27, offset: 3710},
						name: "IntegerLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 139, col: 44, offset: 3727},
						name: "StringLiteral",
					},
					&ruleRefExpr{
						pos:  position{line: 139, col: 60, offset: 3743},
						name: "BooleanLiteral",
					},
				},
			},
		},
		{
			name: "IntegerLiteral",
			pos:  position{line: 141, col: 1, offset: 3759},
			expr: &actionExpr{
				pos: position{line: 141, col: 19, offset: 3777},
				run: (*parser).callonIntegerLiteral1,
				expr: &oneOrMoreExpr{
					pos: position{line: 141, col: 19, offset: 3777},
					expr: &charClassMatcher{
						pos:        position{line: 141, col: 19, offset: 3777},
						val:        "[0-9]",
						ranges:     []rune{'0', '9'},
						ignoreCase: false,
						inverted:   false,
					},
				},
			},
		},
		{
			name: "StringLiteral",
			pos:  position{line: 145, col: 1, offset: 3921},
			expr: &actionExpr{
				pos: position{line: 145, col: 18, offset: 3938},
				run: (*parser).callonStringLiteral1,
				expr: &seqExpr{
					pos: position{line: 145, col: 18, offset: 3938},
					exprs: []any{
						&litMatcher{
							pos:        position{line: 145, col: 18, offset: 3938},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
						&labeledExpr{
							pos:   position{line: 145, col: 23, offset: 3943},
							label: "chars",
							expr: &zeroOrMoreExpr{
								pos: position{line: 145, col: 29, offset: 3949},
								expr: &ruleRefExpr{
									pos:  position{line: 145, col: 29, offset: 3949},
									name: "StringCharacter",
								},
							},
						},
						&litMatcher{
							pos:        position{line: 145, col: 46, offset: 3966},
							val:        "\"",
							ignoreCase: false,
							want:       "\"\\\"\"",
						},
					},
				},
			},
		},
		{
			name: "FloatLiteral",
			pos:  position{line: 148, col: 1, offset: 4084},
			expr: &actionExpr{
				pos: position{line: 148, col: 17, offset: 4100},
				run: (*parser).callonFloatLiteral1,
				expr: &seqExpr{
					pos: position{line: 148, col: 17, offset: 4100},
					exprs: []any{
						&oneOrMoreExpr{
							pos: position{line: 148, col: 17, offset: 4100},
							expr: &charClassMatcher{
								pos:        position{line: 148, col: 17, offset: 4100},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
						&litMatcher{
							pos:        position{line: 148, col: 23, offset: 4106},
							val:        ".",
							ignoreCase: false,
							want:       "\".\"",
						},
						&oneOrMoreExpr{
							pos: position{line: 148, col: 26, offset: 4109},
							expr: &charClassMatcher{
								pos:        position{line: 148, col: 26, offset: 4109},
								val:        "[0-9]",
								ranges:     []rune{'0', '9'},
								ignoreCase: false,
								inverted:   false,
							},
						},
					},
				},
			},
		},
		{
			name: "BooleanLiteral",
			pos:  position{line: 152, col: 1, offset: 4265},
			expr: &actionExpr{
				pos: position{line: 152, col: 19, offset: 4283},
				run: (*parser).callonBooleanLiteral1,
				expr: &choiceExpr{
					pos: position{line: 152, col: 20, offset: 4284},
					alternatives: []any{
						&litMatcher{
							pos:        position{line: 152, col: 20, offset: 4284},
							val:        "true",
							ignoreCase: false,
							want:       "\"true\"",
						},
						&litMatcher{
							pos:        position{line: 152, col: 29, offset: 4293},
							val:        "false",
							ignoreCase: false,
							want:       "\"false\"",
						},
					},
				},
			},
		},
		{
			name: "StringCharacter",
			pos:  position{line: 157, col: 1, offset: 4447},
			expr: &choiceExpr{
				pos: position{line: 157, col: 20, offset: 4466},
				alternatives: []any{
					&actionExpr{
						pos: position{line: 157, col: 20, offset: 4466},
						run: (*parser).callonStringCharacter2,
						expr: &seqExpr{
							pos: position{line: 157, col: 20, offset: 4466},
							exprs: []any{
								&notExpr{
									pos: position{line: 157, col: 20, offset: 4466},
									expr: &choiceExpr{
										pos: position{line: 157, col: 22, offset: 4468},
										alternatives: []any{
											&litMatcher{
												pos:        position{line: 157, col: 22, offset: 4468},
												val:        "\"",
												ignoreCase: false,
												want:       "\"\\\"\"",
											},
											&litMatcher{
												pos:        position{line: 157, col: 28, offset: 4474},
												val:        "\\",
												ignoreCase: false,
												want:       "\"\\\\\"",
											},
										},
									},
								},
								&anyMatcher{
									line: 157, col: 34, offset: 4480,
								},
							},
						},
					},
					&actionExpr{
						pos: position{line: 158, col: 5, offset: 4517},
						run: (*parser).callonStringCharacter9,
						expr: &seqExpr{
							pos: position{line: 158, col: 5, offset: 4517},
							exprs: []any{
								&litMatcher{
									pos:        position{line: 158, col: 5, offset: 4517},
									val:        "\\",
									ignoreCase: false,
									want:       "\"\\\\\"",
								},
								&labeledExpr{
									pos:   position{line: 158, col: 10, offset: 4522},
									label: "seq",
									expr: &ruleRefExpr{
										pos:  position{line: 158, col: 14, offset: 4526},
										name: "EscapeSequenceCharacter",
									},
								},
							},
						},
					},
				},
			},
		},
		{
			name: "EscapeSequenceCharacter",
			pos:  position{line: 160, col: 1, offset: 4571},
			expr: &labeledExpr{
				pos:   position{line: 160, col: 28, offset: 4598},
				label: "char",
				expr: &ruleRefExpr{
					pos:  position{line: 160, col: 33, offset: 4603},
					name: "EscapeCharacter",
				},
			},
		},
		{
			name: "EscapeCharacter",
			pos:  position{line: 162, col: 1, offset: 4620},
			expr: &choiceExpr{
				pos: position{line: 162, col: 20, offset: 4639},
				alternatives: []any{
					&litMatcher{
						pos:        position{line: 162, col: 20, offset: 4639},
						val:        "'",
						ignoreCase: false,
						want:       "\"'\"",
					},
					&litMatcher{
						pos:        position{line: 163, col: 5, offset: 4647},
						val:        "\"",
						ignoreCase: false,
						want:       "\"\\\"\"",
					},
					&litMatcher{
						pos:        position{line: 164, col: 5, offset: 4655},
						val:        "\\",
						ignoreCase: false,
						want:       "\"\\\\\"",
					},
					&actionExpr{
						pos: position{line: 165, col: 5, offset: 4664},
						run: (*parser).callonEscapeCharacter5,
						expr: &litMatcher{
							pos:        position{line: 165, col: 5, offset: 4664},
							val:        "b",
							ignoreCase: false,
							want:       "\"b\"",
						},
					},
					&actionExpr{
						pos: position{line: 166, col: 5, offset: 4693},
						run: (*parser).callonEscapeCharacter7,
						expr: &litMatcher{
							pos:        position{line: 166, col: 5, offset: 4693},
							val:        "f",
							ignoreCase: false,
							want:       "\"f\"",
						},
					},
					&actionExpr{
						pos: position{line: 167, col: 5, offset: 4722},
						run: (*parser).callonEscapeCharacter9,
						expr: &litMatcher{
							pos:        position{line: 167, col: 5, offset: 4722},
							val:        "n",
							ignoreCase: false,
							want:       "\"n\"",
						},
					},
					&actionExpr{
						pos: position{line: 168, col: 5, offset: 4751},
						run: (*parser).callonEscapeCharacter11,
						expr: &litMatcher{
							pos:        position{line: 168, col: 5, offset: 4751},
							val:        "r",
							ignoreCase: false,
							want:       "\"r\"",
						},
					},
					&actionExpr{
						pos: position{line: 169, col: 5, offset: 4780},
						run: (*parser).callonEscapeCharacter13,
						expr: &litMatcher{
							pos:        position{line: 169, col: 5, offset: 4780},
							val:        "t",
							ignoreCase: false,
							want:       "\"t\"",
						},
					},
				},
			},
		},
		{
			name: "non_escape_character",
			pos:  position{line: 171, col: 1, offset: 4806},
			expr: &actionExpr{
				pos: position{line: 171, col: 25, offset: 4830},
				run: (*parser).callonnon_escape_character1,
				expr: &seqExpr{
					pos: position{line: 171, col: 25, offset: 4830},
					exprs: []any{
						&notExpr{
							pos: position{line: 171, col: 25, offset: 4830},
							expr: &ruleRefExpr{
								pos:  position{line: 171, col: 27, offset: 4832},
								name: "escape_character",
							},
						},
						&labeledExpr{
							pos:   position{line: 171, col: 45, offset: 4850},
							label: "char",
							expr: &anyMatcher{
								line: 171, col: 50, offset: 4855,
							},
						},
					},
				},
			},
		},
		{
			name: "ws",
			pos:  position{line: 174, col: 1, offset: 4894},
			expr: &zeroOrMoreExpr{
				pos: position{line: 174, col: 7, offset: 4900},
				expr: &charClassMatcher{
					pos:        position{line: 174, col: 7, offset: 4900},
					val:        "[ \\t\\n\\r]",
					chars:      []rune{' ', '\t', '\n', '\r'},
					ignoreCase: false,
					inverted:   false,
				},
			},
		},
		{
			name: "EOF",
			pos:  position{line: 176, col: 1, offset: 4912},
			expr: &notExpr{
				pos: position{line: 176, col: 8, offset: 4919},
				expr: &anyMatcher{
					line: 176, col: 9, offset: 4920,
				},
			},
		},
	},
}

func (c *current) onInput1(selectStmt any) (any, error) {
	return selectStmt, nil
}

func (p *parser) callonInput1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onInput1(stack["selectStmt"])
}

func (c *current) onSelectStmt15(condition any) (any, error) {
	return condition, nil
}

func (p *parser) callonSelectStmt15() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt15(stack["condition"])
}

func (c *current) onSelectStmt1(columns, table, whereClause any) (any, error) {
	return makeSelectStmt(columns, table, whereClause)
}

func (p *parser) callonSelectStmt1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onSelectStmt1(stack["columns"], stack["table"], stack["whereClause"])
}

func (c *current) onColumnList7(coll any) (any, error) {
	return coll, nil
}

func (p *parser) callonColumnList7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList7(stack["coll"])
}

func (c *current) onColumnList1(column, other_columns any) (any, error) {
	return makeColumnList(column, other_columns)
}

func (p *parser) callonColumnList1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onColumnList1(stack["column"], stack["other_columns"])
}

func (c *current) onTableName1(key any) (any, error) {
	return parsers.Table{Value: key.(string)}, nil
}

func (p *parser) callonTableName1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onTableName1(stack["key"])
}

func (c *current) onFieldPath12(alias any) (any, error) {
	return alias, nil
}

func (p *parser) callonFieldPath12() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFieldPath12(stack["alias"])
}

func (c *current) onFieldPath1(name, path, asClause any) (any, error) {
	return makeFieldPath(name, path, asClause)
}

func (p *parser) callonFieldPath1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFieldPath1(stack["name"], stack["path"], stack["asClause"])
}

func (c *current) onDotFieldAccess1(id any) (any, error) {
	return id, nil
}

func (p *parser) callonDotFieldAccess1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onDotFieldAccess1(stack["id"])
}

func (c *current) onArrayFieldAccess1(id any) (any, error) {
	return id, nil
}

func (p *parser) callonArrayFieldAccess1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onArrayFieldAccess1(stack["id"])
}

func (c *current) onIdentifier1() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonIdentifier1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIdentifier1()
}

func (c *current) onCondition1(expression any) (any, error) {
	return expression, nil
}

func (p *parser) callonCondition1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onCondition1(stack["expression"])
}

func (c *current) onOrExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonOrExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression7(stack["ex"])
}

func (c *current) onOrExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeOr)
}

func (p *parser) callonOrExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onOrExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onAndExpression7(ex any) (any, error) {
	return ex, nil
}

func (p *parser) callonAndExpression7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression7(stack["ex"])
}

func (c *current) onAndExpression1(ex1, ex2 any) (any, error) {
	return combineExpressions(ex1, ex2, parsers.LogicalExpressionTypeAnd)
}

func (p *parser) callonAndExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onAndExpression1(stack["ex1"], stack["ex2"])
}

func (c *current) onComparisonExpression1(left, op, right any) (any, error) {
	return parsers.ComparisonExpression{Left: left, Right: right, Operation: string(op.([]uint8))}, nil
}

func (p *parser) callonComparisonExpression1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonExpression1(stack["left"], stack["op"], stack["right"])
}

func (c *current) onComparisonOperator7() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonComparisonOperator7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onComparisonOperator7()
}

func (c *current) onIntegerLiteral1() (any, error) {
	intValue, _ := strconv.Atoi(string(c.text))
	return parsers.Constant{Type: parsers.ConstantTypeInteger, Value: intValue}, nil
}

func (p *parser) callonIntegerLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onIntegerLiteral1()
}

func (c *current) onStringLiteral1(chars any) (any, error) {
	return parsers.Constant{Type: parsers.ConstantTypeString, Value: joinStrings(chars.([]interface{}))}, nil
}

func (p *parser) callonStringLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringLiteral1(stack["chars"])
}

func (c *current) onFloatLiteral1() (any, error) {
	floatValue, _ := strconv.ParseFloat(string(c.text), 64)
	return parsers.Constant{Type: parsers.ConstantTypeFloat, Value: floatValue}, nil
}

func (p *parser) callonFloatLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onFloatLiteral1()
}

func (c *current) onBooleanLiteral1() (any, error) {
	boolValue, _ := strconv.ParseBool(string(c.text))
	return parsers.Constant{Type: parsers.ConstantTypeBoolean, Value: boolValue}, nil
}

func (p *parser) callonBooleanLiteral1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onBooleanLiteral1()
}

func (c *current) onStringCharacter2() (any, error) {
	return string(c.text), nil
}

func (p *parser) callonStringCharacter2() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter2()
}

func (c *current) onStringCharacter9(seq any) (any, error) {
	return seq, nil
}

func (p *parser) callonStringCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onStringCharacter9(stack["seq"])
}

func (c *current) onEscapeCharacter5() (any, error) {
	return "\b", nil
}

func (p *parser) callonEscapeCharacter5() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter5()
}

func (c *current) onEscapeCharacter7() (any, error) {
	return "\f", nil
}

func (p *parser) callonEscapeCharacter7() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter7()
}

func (c *current) onEscapeCharacter9() (any, error) {
	return "\n", nil
}

func (p *parser) callonEscapeCharacter9() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter9()
}

func (c *current) onEscapeCharacter11() (any, error) {
	return "\r", nil
}

func (p *parser) callonEscapeCharacter11() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter11()
}

func (c *current) onEscapeCharacter13() (any, error) {
	return "\t", nil
}

func (p *parser) callonEscapeCharacter13() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onEscapeCharacter13()
}

func (c *current) onnon_escape_character1(char any) (any, error) {
	return string(c.text), nil
}

func (p *parser) callonnon_escape_character1() (any, error) {
	stack := p.vstack[len(p.vstack)-1]
	_ = stack
	return p.cur.onnon_escape_character1(stack["char"])
}

var (
	// errNoRule is returned when the grammar to parse has no rule.
	errNoRule = errors.New("grammar has no rule")

	// errInvalidEntrypoint is returned when the specified entrypoint rule
	// does not exit.
	errInvalidEntrypoint = errors.New("invalid entrypoint")

	// errInvalidEncoding is returned when the source is not properly
	// utf8-encoded.
	errInvalidEncoding = errors.New("invalid encoding")

	// errMaxExprCnt is used to signal that the maximum number of
	// expressions have been parsed.
	errMaxExprCnt = errors.New("max number of expressions parsed")
)

// Option is a function that can set an option on the parser. It returns
// the previous setting as an Option.
type Option func(*parser) Option

// MaxExpressions creates an Option to stop parsing after the provided
// number of expressions have been parsed, if the value is 0 then the parser will
// parse for as many steps as needed (possibly an infinite number).
//
// The default for maxExprCnt is 0.
func MaxExpressions(maxExprCnt uint64) Option {
	return func(p *parser) Option {
		oldMaxExprCnt := p.maxExprCnt
		p.maxExprCnt = maxExprCnt
		return MaxExpressions(oldMaxExprCnt)
	}
}

// Entrypoint creates an Option to set the rule name to use as entrypoint.
// The rule name must have been specified in the -alternate-entrypoints
// if generating the parser with the -optimize-grammar flag, otherwise
// it may have been optimized out. Passing an empty string sets the
// entrypoint to the first rule in the grammar.
//
// The default is to start parsing at the first rule in the grammar.
func Entrypoint(ruleName string) Option {
	return func(p *parser) Option {
		oldEntrypoint := p.entrypoint
		p.entrypoint = ruleName
		if ruleName == "" {
			p.entrypoint = g.rules[0].name
		}
		return Entrypoint(oldEntrypoint)
	}
}

// Statistics adds a user provided Stats struct to the parser to allow
// the user to process the results after the parsing has finished.
// Also the key for the "no match" counter is set.
//
// Example usage:
//
//	input := "input"
//	stats := Stats{}
//	_, err := Parse("input-file", []byte(input), Statistics(&stats, "no match"))
//	if err != nil {
//	    log.Panicln(err)
//	}
//	b, err := json.MarshalIndent(stats.ChoiceAltCnt, "", "  ")
//	if err != nil {
//	    log.Panicln(err)
//	}
//	fmt.Println(string(b))
func Statistics(stats *Stats, choiceNoMatch string) Option {
	return func(p *parser) Option {
		oldStats := p.Stats
		p.Stats = stats
		oldChoiceNoMatch := p.choiceNoMatch
		p.choiceNoMatch = choiceNoMatch
		if p.Stats.ChoiceAltCnt == nil {
			p.Stats.ChoiceAltCnt = make(map[string]map[string]int)
		}
		return Statistics(oldStats, oldChoiceNoMatch)
	}
}

// Debug creates an Option to set the debug flag to b. When set to true,
// debugging information is printed to stdout while parsing.
//
// The default is false.
func Debug(b bool) Option {
	return func(p *parser) Option {
		old := p.debug
		p.debug = b
		return Debug(old)
	}
}

// Memoize creates an Option to set the memoize flag to b. When set to true,
// the parser will cache all results so each expression is evaluated only
// once. This guarantees linear parsing time even for pathological cases,
// at the expense of more memory and slower times for typical cases.
//
// The default is false.
func Memoize(b bool) Option {
	return func(p *parser) Option {
		old := p.memoize
		p.memoize = b
		return Memoize(old)
	}
}

// AllowInvalidUTF8 creates an Option to allow invalid UTF-8 bytes.
// Every invalid UTF-8 byte is treated as a utf8.RuneError (U+FFFD)
// by character class matchers and is matched by the any matcher.
// The returned matched value, c.text and c.offset are NOT affected.
//
// The default is false.
func AllowInvalidUTF8(b bool) Option {
	return func(p *parser) Option {
		old := p.allowInvalidUTF8
		p.allowInvalidUTF8 = b
		return AllowInvalidUTF8(old)
	}
}

// Recover creates an Option to set the recover flag to b. When set to
// true, this causes the parser to recover from panics and convert it
// to an error. Setting it to false can be useful while debugging to
// access the full stack trace.
//
// The default is true.
func Recover(b bool) Option {
	return func(p *parser) Option {
		old := p.recover
		p.recover = b
		return Recover(old)
	}
}

// GlobalStore creates an Option to set a key to a certain value in
// the globalStore.
func GlobalStore(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.globalStore[key]
		p.cur.globalStore[key] = value
		return GlobalStore(key, old)
	}
}

// InitState creates an Option to set a key to a certain value in
// the global "state" store.
func InitState(key string, value any) Option {
	return func(p *parser) Option {
		old := p.cur.state[key]
		p.cur.state[key] = value
		return InitState(key, old)
	}
}

// ParseFile parses the file identified by filename.
func ParseFile(filename string, opts ...Option) (i any, err error) {
	f, err := os.Open(filename)
	if err != nil {
		return nil, err
	}
	defer func() {
		if closeErr := f.Close(); closeErr != nil {
			err = closeErr
		}
	}()
	return ParseReader(filename, f, opts...)
}

// ParseReader parses the data from r using filename as information in the
// error messages.
func ParseReader(filename string, r io.Reader, opts ...Option) (any, error) {
	b, err := io.ReadAll(r)
	if err != nil {
		return nil, err
	}

	return Parse(filename, b, opts...)
}

// Parse parses the data from b using filename as information in the
// error messages.
func Parse(filename string, b []byte, opts ...Option) (any, error) {
	return newParser(filename, b, opts...).parse(g)
}

// position records a position in the text.
type position struct {
	line, col, offset int
}

func (p position) String() string {
	return strconv.Itoa(p.line) + ":" + strconv.Itoa(p.col) + " [" + strconv.Itoa(p.offset) + "]"
}

// savepoint stores all state required to go back to this point in the
// parser.
type savepoint struct {
	position
	rn rune
	w  int
}

type current struct {
	pos  position // start position of the match
	text []byte   // raw text of the match

	// state is a store for arbitrary key,value pairs that the user wants to be
	// tied to the backtracking of the parser.
	// This is always rolled back if a parsing rule fails.
	state storeDict

	// globalStore is a general store for the user to store arbitrary key-value
	// pairs that they need to manage and that they do not want tied to the
	// backtracking of the parser. This is only modified by the user and never
	// rolled back by the parser. It is always up to the user to keep this in a
	// consistent state.
	globalStore storeDict
}

type storeDict map[string]any

// the AST types...

type grammar struct {
	pos   position
	rules []*rule
}

type rule struct {
	pos         position
	name        string
	displayName string
	expr        any
}

type choiceExpr struct {
	pos          position
	alternatives []any
}

type actionExpr struct {
	pos  position
	expr any
	run  func(*parser) (any, error)
}

type recoveryExpr struct {
	pos          position
	expr         any
	recoverExpr  any
	failureLabel []string
}

type seqExpr struct {
	pos   position
	exprs []any
}

type throwExpr struct {
	pos   position
	label string
}

type labeledExpr struct {
	pos   position
	label string
	expr  any
}

type expr struct {
	pos  position
	expr any
}

type (
	andExpr        expr
	notExpr        expr
	zeroOrOneExpr  expr
	zeroOrMoreExpr expr
	oneOrMoreExpr  expr
)

type ruleRefExpr struct {
	pos  position
	name string
}

type stateCodeExpr struct {
	pos position
	run func(*parser) error
}

type andCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type notCodeExpr struct {
	pos position
	run func(*parser) (bool, error)
}

type litMatcher struct {
	pos        position
	val        string
	ignoreCase bool
	want       string
}

type charClassMatcher struct {
	pos             position
	val             string
	basicLatinChars [128]bool
	chars           []rune
	ranges          []rune
	classes         []*unicode.RangeTable
	ignoreCase      bool
	inverted        bool
}

type anyMatcher position

// errList cumulates the errors found by the parser.
type errList []error

func (e *errList) add(err error) {
	*e = append(*e, err)
}

func (e errList) err() error {
	if len(e) == 0 {
		return nil
	}
	e.dedupe()
	return e
}

func (e *errList) dedupe() {
	var cleaned []error
	set := make(map[string]bool)
	for _, err := range *e {
		if msg := err.Error(); !set[msg] {
			set[msg] = true
			cleaned = append(cleaned, err)
		}
	}
	*e = cleaned
}

func (e errList) Error() string {
	switch len(e) {
	case 0:
		return ""
	case 1:
		return e[0].Error()
	default:
		var buf bytes.Buffer

		for i, err := range e {
			if i > 0 {
				buf.WriteRune('\n')
			}
			buf.WriteString(err.Error())
		}
		return buf.String()
	}
}

// parserError wraps an error with a prefix indicating the rule in which
// the error occurred. The original error is stored in the Inner field.
type parserError struct {
	Inner    error
	pos      position
	prefix   string
	expected []string
}

// Error returns the error message.
func (p *parserError) Error() string {
	return p.prefix + ": " + p.Inner.Error()
}

// newParser creates a parser with the specified input source and options.
func newParser(filename string, b []byte, opts ...Option) *parser {
	stats := Stats{
		ChoiceAltCnt: make(map[string]map[string]int),
	}

	p := &parser{
		filename: filename,
		errs:     new(errList),
		data:     b,
		pt:       savepoint{position: position{line: 1}},
		recover:  true,
		cur: current{
			state:       make(storeDict),
			globalStore: make(storeDict),
		},
		maxFailPos:      position{col: 1, line: 1},
		maxFailExpected: make([]string, 0, 20),
		Stats:           &stats,
		// start rule is rule [0] unless an alternate entrypoint is specified
		entrypoint: g.rules[0].name,
	}
	p.setOptions(opts)

	if p.maxExprCnt == 0 {
		p.maxExprCnt = math.MaxUint64
	}

	return p
}

// setOptions applies the options to the parser.
func (p *parser) setOptions(opts []Option) {
	for _, opt := range opts {
		opt(p)
	}
}

type resultTuple struct {
	v   any
	b   bool
	end savepoint
}

const choiceNoMatch = -1

// Stats stores some statistics, gathered during parsing
type Stats struct {
	// ExprCnt counts the number of expressions processed during parsing
	// This value is compared to the maximum number of expressions allowed
	// (set by the MaxExpressions option).
	ExprCnt uint64

	// ChoiceAltCnt is used to count for each ordered choice expression,
	// which alternative is used how may times.
	// These numbers allow to optimize the order of the ordered choice expression
	// to increase the performance of the parser
	//
	// The outer key of ChoiceAltCnt is composed of the name of the rule as well
	// as the line and the column of the ordered choice.
	// The inner key of ChoiceAltCnt is the number (one-based) of the matching alternative.
	// For each alternative the number of matches are counted. If an ordered choice does not
	// match, a special counter is incremented. The name of this counter is set with
	// the parser option Statistics.
	// For an alternative to be included in ChoiceAltCnt, it has to match at least once.
	ChoiceAltCnt map[string]map[string]int
}

type parser struct {
	filename string
	pt       savepoint
	cur      current

	data []byte
	errs *errList

	depth   int
	recover bool
	debug   bool

	memoize bool
	// memoization table for the packrat algorithm:
	// map[offset in source] map[expression or rule] {value, match}
	memo map[int]map[any]resultTuple

	// rules table, maps the rule identifier to the rule node
	rules map[string]*rule
	// variables stack, map of label to value
	vstack []map[string]any
	// rule stack, allows identification of the current rule in errors
	rstack []*rule

	// parse fail
	maxFailPos            position
	maxFailExpected       []string
	maxFailInvertExpected bool

	// max number of expressions to be parsed
	maxExprCnt uint64
	// entrypoint for the parser
	entrypoint string

	allowInvalidUTF8 bool

	*Stats

	choiceNoMatch string
	// recovery expression stack, keeps track of the currently available recovery expression, these are traversed in reverse
	recoveryStack []map[string]any
}

// push a variable set on the vstack.
func (p *parser) pushV() {
	if cap(p.vstack) == len(p.vstack) {
		// create new empty slot in the stack
		p.vstack = append(p.vstack, nil)
	} else {
		// slice to 1 more
		p.vstack = p.vstack[:len(p.vstack)+1]
	}

	// get the last args set
	m := p.vstack[len(p.vstack)-1]
	if m != nil && len(m) == 0 {
		// empty map, all good
		return
	}

	m = make(map[string]any)
	p.vstack[len(p.vstack)-1] = m
}

// pop a variable set from the vstack.
func (p *parser) popV() {
	// if the map is not empty, clear it
	m := p.vstack[len(p.vstack)-1]
	if len(m) > 0 {
		// GC that map
		p.vstack[len(p.vstack)-1] = nil
	}
	p.vstack = p.vstack[:len(p.vstack)-1]
}

// push a recovery expression with its labels to the recoveryStack
func (p *parser) pushRecovery(labels []string, expr any) {
	if cap(p.recoveryStack) == len(p.recoveryStack) {
		// create new empty slot in the stack
		p.recoveryStack = append(p.recoveryStack, nil)
	} else {
		// slice to 1 more
		p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)+1]
	}

	m := make(map[string]any, len(labels))
	for _, fl := range labels {
		m[fl] = expr
	}
	p.recoveryStack[len(p.recoveryStack)-1] = m
}

// pop a recovery expression from the recoveryStack
func (p *parser) popRecovery() {
	// GC that map
	p.recoveryStack[len(p.recoveryStack)-1] = nil

	p.recoveryStack = p.recoveryStack[:len(p.recoveryStack)-1]
}

func (p *parser) print(prefix, s string) string {
	if !p.debug {
		return s
	}

	fmt.Printf("%s %d:%d:%d: %s [%#U]\n",
		prefix, p.pt.line, p.pt.col, p.pt.offset, s, p.pt.rn)
	return s
}

func (p *parser) printIndent(mark string, s string) string {
	return p.print(strings.Repeat(" ", p.depth)+mark, s)
}

func (p *parser) in(s string) string {
	res := p.printIndent(">", s)
	p.depth++
	return res
}

func (p *parser) out(s string) string {
	p.depth--
	return p.printIndent("<", s)
}

func (p *parser) addErr(err error) {
	p.addErrAt(err, p.pt.position, []string{})
}

func (p *parser) addErrAt(err error, pos position, expected []string) {
	var buf bytes.Buffer
	if p.filename != "" {
		buf.WriteString(p.filename)
	}
	if buf.Len() > 0 {
		buf.WriteString(":")
	}
	buf.WriteString(fmt.Sprintf("%d:%d (%d)", pos.line, pos.col, pos.offset))
	if len(p.rstack) > 0 {
		if buf.Len() > 0 {
			buf.WriteString(": ")
		}
		rule := p.rstack[len(p.rstack)-1]
		if rule.displayName != "" {
			buf.WriteString("rule " + rule.displayName)
		} else {
			buf.WriteString("rule " + rule.name)
		}
	}
	pe := &parserError{Inner: err, pos: pos, prefix: buf.String(), expected: expected}
	p.errs.add(pe)
}

func (p *parser) failAt(fail bool, pos position, want string) {
	// process fail if parsing fails and not inverted or parsing succeeds and invert is set
	if fail == p.maxFailInvertExpected {
		if pos.offset < p.maxFailPos.offset {
			return
		}

		if pos.offset > p.maxFailPos.offset {
			p.maxFailPos = pos
			p.maxFailExpected = p.maxFailExpected[:0]
		}

		if p.maxFailInvertExpected {
			want = "!" + want
		}
		p.maxFailExpected = append(p.maxFailExpected, want)
	}
}

// read advances the parser to the next rune.
func (p *parser) read() {
	p.pt.offset += p.pt.w
	rn, n := utf8.DecodeRune(p.data[p.pt.offset:])
	p.pt.rn = rn
	p.pt.w = n
	p.pt.col++
	if rn == '\n' {
		p.pt.line++
		p.pt.col = 0
	}

	if rn == utf8.RuneError && n == 1 { // see utf8.DecodeRune
		if !p.allowInvalidUTF8 {
			p.addErr(errInvalidEncoding)
		}
	}
}

// restore parser position to the savepoint pt.
func (p *parser) restore(pt savepoint) {
	if p.debug {
		defer p.out(p.in("restore"))
	}
	if pt.offset == p.pt.offset {
		return
	}
	p.pt = pt
}

// Cloner is implemented by any value that has a Clone method, which returns a
// copy of the value. This is mainly used for types which are not passed by
// value (e.g map, slice, chan) or structs that contain such types.
//
// This is used in conjunction with the global state feature to create proper
// copies of the state to allow the parser to properly restore the state in
// the case of backtracking.
type Cloner interface {
	Clone() any
}

var statePool = &sync.Pool{
	New: func() any { return make(storeDict) },
}

func (sd storeDict) Discard() {
	for k := range sd {
		delete(sd, k)
	}
	statePool.Put(sd)
}

// clone and return parser current state.
func (p *parser) cloneState() storeDict {
	if p.debug {
		defer p.out(p.in("cloneState"))
	}

	state := statePool.Get().(storeDict)
	for k, v := range p.cur.state {
		if c, ok := v.(Cloner); ok {
			state[k] = c.Clone()
		} else {
			state[k] = v
		}
	}
	return state
}

// restore parser current state to the state storeDict.
// every restoreState should applied only one time for every cloned state
func (p *parser) restoreState(state storeDict) {
	if p.debug {
		defer p.out(p.in("restoreState"))
	}
	p.cur.state.Discard()
	p.cur.state = state
}

// get the slice of bytes from the savepoint start to the current position.
func (p *parser) sliceFrom(start savepoint) []byte {
	return p.data[start.position.offset:p.pt.position.offset]
}

func (p *parser) getMemoized(node any) (resultTuple, bool) {
	if len(p.memo) == 0 {
		return resultTuple{}, false
	}
	m := p.memo[p.pt.offset]
	if len(m) == 0 {
		return resultTuple{}, false
	}
	res, ok := m[node]
	return res, ok
}

func (p *parser) setMemoized(pt savepoint, node any, tuple resultTuple) {
	if p.memo == nil {
		p.memo = make(map[int]map[any]resultTuple)
	}
	m := p.memo[pt.offset]
	if m == nil {
		m = make(map[any]resultTuple)
		p.memo[pt.offset] = m
	}
	m[node] = tuple
}

func (p *parser) buildRulesTable(g *grammar) {
	p.rules = make(map[string]*rule, len(g.rules))
	for _, r := range g.rules {
		p.rules[r.name] = r
	}
}

func (p *parser) parse(g *grammar) (val any, err error) {
	if len(g.rules) == 0 {
		p.addErr(errNoRule)
		return nil, p.errs.err()
	}

	// TODO : not super critical but this could be generated
	p.buildRulesTable(g)

	if p.recover {
		// panic can be used in action code to stop parsing immediately
		// and return the panic as an error.
		defer func() {
			if e := recover(); e != nil {
				if p.debug {
					defer p.out(p.in("panic handler"))
				}
				val = nil
				switch e := e.(type) {
				case error:
					p.addErr(e)
				default:
					p.addErr(fmt.Errorf("%v", e))
				}
				err = p.errs.err()
			}
		}()
	}

	startRule, ok := p.rules[p.entrypoint]
	if !ok {
		p.addErr(errInvalidEntrypoint)
		return nil, p.errs.err()
	}

	p.read() // advance to first rune
	val, ok = p.parseRuleWrap(startRule)
	if !ok {
		if len(*p.errs) == 0 {
			// If parsing fails, but no errors have been recorded, the expected values
			// for the farthest parser position are returned as error.
			maxFailExpectedMap := make(map[string]struct{}, len(p.maxFailExpected))
			for _, v := range p.maxFailExpected {
				maxFailExpectedMap[v] = struct{}{}
			}
			expected := make([]string, 0, len(maxFailExpectedMap))
			eof := false
			if _, ok := maxFailExpectedMap["!."]; ok {
				delete(maxFailExpectedMap, "!.")
				eof = true
			}
			for k := range maxFailExpectedMap {
				expected = append(expected, k)
			}
			sort.Strings(expected)
			if eof {
				expected = append(expected, "EOF")
			}
			p.addErrAt(errors.New("no match found, expected: "+listJoin(expected, ", ", "or")), p.maxFailPos, expected)
		}

		return nil, p.errs.err()
	}
	return val, p.errs.err()
}

func listJoin(list []string, sep string, lastSep string) string {
	switch len(list) {
	case 0:
		return ""
	case 1:
		return list[0]
	default:
		return strings.Join(list[:len(list)-1], sep) + " " + lastSep + " " + list[len(list)-1]
	}
}

func (p *parser) parseRuleMemoize(rule *rule) (any, bool) {
	res, ok := p.getMemoized(rule)
	if ok {
		p.restore(res.end)
		return res.v, res.b
	}

	startMark := p.pt
	val, ok := p.parseRule(rule)
	p.setMemoized(startMark, rule, resultTuple{val, ok, p.pt})

	return val, ok
}

func (p *parser) parseRuleWrap(rule *rule) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRule " + rule.name))
	}
	var (
		val       any
		ok        bool
		startMark = p.pt
	)

	if p.memoize {
		val, ok = p.parseRuleMemoize(rule)
	} else {
		val, ok = p.parseRule(rule)
	}

	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(startMark)))
	}
	return val, ok
}

func (p *parser) parseRule(rule *rule) (any, bool) {
	p.rstack = append(p.rstack, rule)
	p.pushV()
	val, ok := p.parseExprWrap(rule.expr)
	p.popV()
	p.rstack = p.rstack[:len(p.rstack)-1]
	return val, ok
}

func (p *parser) parseExprWrap(expr any) (any, bool) {
	var pt savepoint

	if p.memoize {
		res, ok := p.getMemoized(expr)
		if ok {
			p.restore(res.end)
			return res.v, res.b
		}
		pt = p.pt
	}

	val, ok := p.parseExpr(expr)

	if p.memoize {
		p.setMemoized(pt, expr, resultTuple{val, ok, p.pt})
	}
	return val, ok
}

func (p *parser) parseExpr(expr any) (any, bool) {
	p.ExprCnt++
	if p.ExprCnt > p.maxExprCnt {
		panic(errMaxExprCnt)
	}

	var val any
	var ok bool
	switch expr := expr.(type) {
	case *actionExpr:
		val, ok = p.parseActionExpr(expr)
	case *andCodeExpr:
		val, ok = p.parseAndCodeExpr(expr)
	case *andExpr:
		val, ok = p.parseAndExpr(expr)
	case *anyMatcher:
		val, ok = p.parseAnyMatcher(expr)
	case *charClassMatcher:
		val, ok = p.parseCharClassMatcher(expr)
	case *choiceExpr:
		val, ok = p.parseChoiceExpr(expr)
	case *labeledExpr:
		val, ok = p.parseLabeledExpr(expr)
	case *litMatcher:
		val, ok = p.parseLitMatcher(expr)
	case *notCodeExpr:
		val, ok = p.parseNotCodeExpr(expr)
	case *notExpr:
		val, ok = p.parseNotExpr(expr)
	case *oneOrMoreExpr:
		val, ok = p.parseOneOrMoreExpr(expr)
	case *recoveryExpr:
		val, ok = p.parseRecoveryExpr(expr)
	case *ruleRefExpr:
		val, ok = p.parseRuleRefExpr(expr)
	case *seqExpr:
		val, ok = p.parseSeqExpr(expr)
	case *stateCodeExpr:
		val, ok = p.parseStateCodeExpr(expr)
	case *throwExpr:
		val, ok = p.parseThrowExpr(expr)
	case *zeroOrMoreExpr:
		val, ok = p.parseZeroOrMoreExpr(expr)
	case *zeroOrOneExpr:
		val, ok = p.parseZeroOrOneExpr(expr)
	default:
		panic(fmt.Sprintf("unknown expression type %T", expr))
	}
	return val, ok
}

func (p *parser) parseActionExpr(act *actionExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseActionExpr"))
	}

	start := p.pt
	val, ok := p.parseExprWrap(act.expr)
	if ok {
		p.cur.pos = start.position
		p.cur.text = p.sliceFrom(start)
		state := p.cloneState()
		actVal, err := act.run(p)
		if err != nil {
			p.addErrAt(err, start.position, []string{})
		}
		p.restoreState(state)

		val = actVal
	}
	if ok && p.debug {
		p.printIndent("MATCH", string(p.sliceFrom(start)))
	}
	return val, ok
}

func (p *parser) parseAndCodeExpr(and *andCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndCodeExpr"))
	}

	state := p.cloneState()

	ok, err := and.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, ok
}

func (p *parser) parseAndExpr(and *andExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAndExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	_, ok := p.parseExprWrap(and.expr)
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, ok
}

func (p *parser) parseAnyMatcher(any *anyMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseAnyMatcher"))
	}

	if p.pt.rn == utf8.RuneError && p.pt.w == 0 {
		// EOF - see utf8.DecodeRune
		p.failAt(false, p.pt.position, ".")
		return nil, false
	}
	start := p.pt
	p.read()
	p.failAt(true, start.position, ".")
	return p.sliceFrom(start), true
}

func (p *parser) parseCharClassMatcher(chr *charClassMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseCharClassMatcher"))
	}

	cur := p.pt.rn
	start := p.pt

	// can't match EOF
	if cur == utf8.RuneError && p.pt.w == 0 { // see utf8.DecodeRune
		p.failAt(false, start.position, chr.val)
		return nil, false
	}

	if chr.ignoreCase {
		cur = unicode.ToLower(cur)
	}

	// try to match in the list of available chars
	for _, rn := range chr.chars {
		if rn == cur {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of ranges
	for i := 0; i < len(chr.ranges); i += 2 {
		if cur >= chr.ranges[i] && cur <= chr.ranges[i+1] {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	// try to match in the list of Unicode classes
	for _, cl := range chr.classes {
		if unicode.Is(cl, cur) {
			if chr.inverted {
				p.failAt(false, start.position, chr.val)
				return nil, false
			}
			p.read()
			p.failAt(true, start.position, chr.val)
			return p.sliceFrom(start), true
		}
	}

	if chr.inverted {
		p.read()
		p.failAt(true, start.position, chr.val)
		return p.sliceFrom(start), true
	}
	p.failAt(false, start.position, chr.val)
	return nil, false
}

func (p *parser) incChoiceAltCnt(ch *choiceExpr, altI int) {
	choiceIdent := fmt.Sprintf("%s %d:%d", p.rstack[len(p.rstack)-1].name, ch.pos.line, ch.pos.col)
	m := p.ChoiceAltCnt[choiceIdent]
	if m == nil {
		m = make(map[string]int)
		p.ChoiceAltCnt[choiceIdent] = m
	}
	// We increment altI by 1, so the keys do not start at 0
	alt := strconv.Itoa(altI + 1)
	if altI == choiceNoMatch {
		alt = p.choiceNoMatch
	}
	m[alt]++
}

func (p *parser) parseChoiceExpr(ch *choiceExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseChoiceExpr"))
	}

	for altI, alt := range ch.alternatives {
		// dummy assignment to prevent compile error if optimized
		_ = altI

		state := p.cloneState()

		p.pushV()
		val, ok := p.parseExprWrap(alt)
		p.popV()
		if ok {
			p.incChoiceAltCnt(ch, altI)
			return val, ok
		}
		p.restoreState(state)
	}
	p.incChoiceAltCnt(ch, choiceNoMatch)
	return nil, false
}

func (p *parser) parseLabeledExpr(lab *labeledExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLabeledExpr"))
	}

	p.pushV()
	val, ok := p.parseExprWrap(lab.expr)
	p.popV()
	if ok && lab.label != "" {
		m := p.vstack[len(p.vstack)-1]
		m[lab.label] = val
	}
	return val, ok
}

func (p *parser) parseLitMatcher(lit *litMatcher) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseLitMatcher"))
	}

	start := p.pt
	for _, want := range lit.val {
		cur := p.pt.rn
		if lit.ignoreCase {
			cur = unicode.ToLower(cur)
		}
		if cur != want {
			p.failAt(false, start.position, lit.want)
			p.restore(start)
			return nil, false
		}
		p.read()
	}
	p.failAt(true, start.position, lit.want)
	return p.sliceFrom(start), true
}

func (p *parser) parseNotCodeExpr(not *notCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotCodeExpr"))
	}

	state := p.cloneState()

	ok, err := not.run(p)
	if err != nil {
		p.addErr(err)
	}
	p.restoreState(state)

	return nil, !ok
}

func (p *parser) parseNotExpr(not *notExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseNotExpr"))
	}

	pt := p.pt
	state := p.cloneState()
	p.pushV()
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	_, ok := p.parseExprWrap(not.expr)
	p.maxFailInvertExpected = !p.maxFailInvertExpected
	p.popV()
	p.restoreState(state)
	p.restore(pt)

	return nil, !ok
}

func (p *parser) parseOneOrMoreExpr(expr *oneOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseOneOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			if len(vals) == 0 {
				// did not match once, no match
				return nil, false
			}
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseRecoveryExpr(recover *recoveryExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRecoveryExpr (" + strings.Join(recover.failureLabel, ",") + ")"))
	}

	p.pushRecovery(recover.failureLabel, recover.recoverExpr)
	val, ok := p.parseExprWrap(recover.expr)
	p.popRecovery()

	return val, ok
}

func (p *parser) parseRuleRefExpr(ref *ruleRefExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseRuleRefExpr " + ref.name))
	}

	if ref.name == "" {
		panic(fmt.Sprintf("%s: invalid rule: missing name", ref.pos))
	}

	rule := p.rules[ref.name]
	if rule == nil {
		p.addErr(fmt.Errorf("undefined rule: %s", ref.name))
		return nil, false
	}
	return p.parseRuleWrap(rule)
}

func (p *parser) parseSeqExpr(seq *seqExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseSeqExpr"))
	}

	vals := make([]any, 0, len(seq.exprs))

	pt := p.pt
	state := p.cloneState()
	for _, expr := range seq.exprs {
		val, ok := p.parseExprWrap(expr)
		if !ok {
			p.restoreState(state)
			p.restore(pt)
			return nil, false
		}
		vals = append(vals, val)
	}
	return vals, true
}

func (p *parser) parseStateCodeExpr(state *stateCodeExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseStateCodeExpr"))
	}

	err := state.run(p)
	if err != nil {
		p.addErr(err)
	}
	return nil, true
}

func (p *parser) parseThrowExpr(expr *throwExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseThrowExpr"))
	}

	for i := len(p.recoveryStack) - 1; i >= 0; i-- {
		if recoverExpr, ok := p.recoveryStack[i][expr.label]; ok {
			if val, ok := p.parseExprWrap(recoverExpr); ok {
				return val, ok
			}
		}
	}

	return nil, false
}

func (p *parser) parseZeroOrMoreExpr(expr *zeroOrMoreExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrMoreExpr"))
	}

	var vals []any

	for {
		p.pushV()
		val, ok := p.parseExprWrap(expr.expr)
		p.popV()
		if !ok {
			return vals, true
		}
		vals = append(vals, val)
	}
}

func (p *parser) parseZeroOrOneExpr(expr *zeroOrOneExpr) (any, bool) {
	if p.debug {
		defer p.out(p.in("parseZeroOrOneExpr"))
	}

	p.pushV()
	val, _ := p.parseExprWrap(expr.expr)
	p.popV()
	// whether it matched or not, consider it a match
	return val, true
}
